summaryrefslogtreecommitdiffstats
path: root/scripts/gcc-version.sh
diff options
context:
space:
mode:
authorMasahiro Yamada <yamada.m@jp.panasonic.com>2013-11-28 16:29:23 +0900
committerTom Rini <trini@ti.com>2013-12-13 09:18:45 -0500
commitdd88ab325cfcc7f803afd40600571b3f9c79319c (patch)
treea5c326330eec571614f1104badcfc41dcbd83661 /scripts/gcc-version.sh
parent392ba5256ab9bf017a9b7320ef0cee98862c908d (diff)
downloadtalos-obmc-uboot-dd88ab325cfcc7f803afd40600571b3f9c79319c.tar.gz
talos-obmc-uboot-dd88ab325cfcc7f803afd40600571b3f9c79319c.zip
Makefile: Move some scripts imported from Linux
We have some scripts imported from Linux Kernel: setlocalversion, checkstack.pl, checkpatch.pl, cleanpatch They are located under tools/ directory in U-Boot now. But they were originally located under scripts/ directory in Linux Kernel. This commit moves them to the original location. It is true that binutils-version.sh and dtc-version.sh do not originate in Linux Kernel, but they should be moved by analogy to gcc-version.sh. Signed-off-by: Masahiro Yamada <yamada.m@jp.panasonic.com>
Diffstat (limited to 'scripts/gcc-version.sh')
-rw-r--r--scripts/gcc-version.sh32
1 files changed, 32 insertions, 0 deletions
diff --git a/scripts/gcc-version.sh b/scripts/gcc-version.sh
new file mode 100644
index 0000000000..debecb5561
--- /dev/null
+++ b/scripts/gcc-version.sh
@@ -0,0 +1,32 @@
+#!/bin/sh
+#
+# gcc-version [-p] gcc-command
+#
+# Prints the gcc version of `gcc-command' in a canonical 4-digit form
+# such as `0295' for gcc-2.95, `0303' for gcc-3.3, etc.
+#
+# With the -p option, prints the patchlevel as well, for example `029503' for
+# gcc-2.95.3, `030301' for gcc-3.3.1, etc.
+#
+
+if [ "$1" = "-p" ] ; then
+ with_patchlevel=1;
+ shift;
+fi
+
+compiler="$*"
+
+if [ ${#compiler} -eq 0 ]; then
+ echo "Error: No compiler specified."
+ printf "Usage:\n\t$0 <gcc-command>\n"
+ exit 1
+fi
+
+MAJOR=$(echo __GNUC__ | $compiler -E -xc - | tail -n 1)
+MINOR=$(echo __GNUC_MINOR__ | $compiler -E -xc - | tail -n 1)
+if [ "x$with_patchlevel" != "x" ] ; then
+ PATCHLEVEL=$(echo __GNUC_PATCHLEVEL__ | $compiler -E -xc - | tail -n 1)
+ printf "%02d%02d%02d\\n" $MAJOR $MINOR $PATCHLEVEL
+else
+ printf "%02d%02d\\n" $MAJOR $MINOR
+fi
OpenPOWER on IntegriCloud